/* ////////////////////////////////////////////////////////////////////////////
 * File:        M3Bland.h
 *
 * Purpose:     Borland Visual C++ compiler header for use/modification by third
 *              party development. This file is included by the Synesis root
 *              header once per compilation unit. Compiler-dependant items
 *              should be placed within this file.
 *
 * Created:     3rd December 1993
 * Updated:     18th February 2005
 *
 * Author:      Matthew Wilson, Synesis Software Pty Ltd.
 *
 * License:     (Licensed under the Synesis Software Standard Public License)
 *
 *              Copyright 1993-2005, Synesis Software Pty Ltd.
 *
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au
 *                          http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              Redistribution and use in source and binary forms, with or
 *              without modification, are permitted provided that the following
 *              conditions are met:
 *
 *              (i) Redistributions of source code must retain the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer.
 *
 *              (ii) Redistributions in binary form must reproduce the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer in the documentation
 *              and/or other materials provided with the distribution.
 *
 *              (iii) Any derived versions of this software (howsoever modified)
 *              remain the sole property of Synesis Software.
 *
 *              (iv) Any derived versions of this software (howsoever modified)
 *              remain subject to all these conditions.
 *
 *              (v) Neither the name of Synesis Software nor the names of any
 *              subdivisions, employees or agents of Synesis Software, nor the
 *              names of any other contributors to this software may be used to
 *              endorse or promote products derived from this software without
 *              specific prior written permission.
 *
 *              This source code is provided by Synesis Software "as is" and any
 *              warranties, whether expressed or implied, including, but not
 *              limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software be liable for any direct, indirect,
 *              incidental, special, exemplary, or consequential damages
 *              (including, but not limited to, procurement of substitute goods
 *              or services; loss of use, data, or profits; or business
 *              interruption) however caused and on any theory of liability,
 *              whether in contract, strict liability, or tort (including
 *              negligence or otherwise) arising in any way out of the use of
 *              this software, even if advised of the possibility of such
 *              damage.
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifdef _SYNSOFT_INCL_H_M3BLAND
# error M3Bland.h has already been included in this compilation unit
#endif /* _SYNSOFT_INCL_H_M3BLAND */

#define _SYNSOFT_INCL_H_M3BLAND

#ifndef _SYNSOFT_DOCUMENTATION_SKIP_SECTION
# define _SYNSOFT_VER_H_M3BLAND_MAJOR        1
# define _SYNSOFT_VER_H_M3BLAND_MINOR        2
# define _SYNSOFT_VER_H_M3BLAND_REVISION     1
# define _SYNSOFT_VER_H_M3BLAND_EDIT         20
#endif /* !_SYNSOFT_DOCUMENTATION_SKIP_SECTION */

#ifdef _SYB_TRACE_INCLUDE_PATH
# pragma message(__FILE__)
#endif /* _SYB_TRACE_INCLUDE_PATH */

#if __SYNSOFT_DVS_COMPILER != __SYNSOFT_VAL_COMPILER_BORLAND
# error M3Bland.h can only be used with Borland compiler. (M3Bland.h may have been included prior to MLBase.h)
#endif /* __SYNSOFT_DVS_COMPILER != __SYNSOFT_VAL_COMPILER_BORLAND */

/* /////////////////////////////////////////////////////////////////////////////
 * Borland-specific
 */

#if __SYNSOFT_DVS_COMPILER_VER_BORLAND <= 0x0402
# ifdef __cplusplus
#  define bad_cast              Bad_cast
# endif /* __cplusplus */
#endif /* __SYNSOFT_DVS_COMPILER_VER_BORLAND <= 0x0402 */

/* /////////////////////////////////////////////////////////////////////////////
 * Compiler warning suppression
 */

/* Borland: "Suggest parentheses to clarify precedence" */
//#pragma warn -8084

/* ////////////////////////////////////////////////////////////////////////// */
