/* ////////////////////////////////////////////////////////////////////////////
 * File:        M3Watcom.h
 *
 * Purpose:     Microsoft Visual C++ compiler header for use/modification by
 *              third party development. This file is included by the Synesis
 *              root header once per compilation unit. Compiler-dependant items
 *              should be placed within this file.
 *
 * Created:     17th November 2003
 * Updated:     18th February 2005
 *
 * Author:      Matthew Wilson, Synesis Software Pty Ltd.
 *
 * License:     (Licensed under the Synesis Software Standard Public License)
 *
 *              Copyright 2003-2005, Synesis Software Pty Ltd.
 *
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au
 *                          http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              Redistribution and use in source and binary forms, with or
 *              without modification, are permitted provided that the following
 *              conditions are met:
 *
 *              (i) Redistributions of source code must retain the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer.
 *
 *              (ii) Redistributions in binary form must reproduce the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer in the documentation
 *              and/or other materials provided with the distribution.
 *
 *              (iii) Any derived versions of this software (howsoever modified)
 *              remain the sole property of Synesis Software.
 *
 *              (iv) Any derived versions of this software (howsoever modified)
 *              remain subject to all these conditions.
 *
 *              (v) Neither the name of Synesis Software nor the names of any
 *              subdivisions, employees or agents of Synesis Software, nor the
 *              names of any other contributors to this software may be used to
 *              endorse or promote products derived from this software without
 *              specific prior written permission.
 *
 *              This source code is provided by Synesis Software "as is" and any
 *              warranties, whether expressed or implied, including, but not
 *              limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software be liable for any direct, indirect,
 *              incidental, special, exemplary, or consequential damages
 *              (including, but not limited to, procurement of substitute goods
 *              or services; loss of use, data, or profits; or business
 *              interruption) however caused and on any theory of liability,
 *              whether in contract, strict liability, or tort (including
 *              negligence or otherwise) arising in any way out of the use of
 *              this software, even if advised of the possibility of such
 *              damage.
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifdef _SYNSOFT_INCL_H_M3WATCOM
# error M3Watcom.h has already been included in this compilation unit
#endif /* _SYNSOFT_INCL_H_M3WATCOM */

#define _SYNSOFT_INCL_H_M3WATCOM

#ifndef _SYNSOFT_DOCUMENTATION_SKIP_SECTION
# define _SYNSOFT_VER_H_M3WATCOM_MAJOR          1
# define _SYNSOFT_VER_H_M3WATCOM_MINOR          0
# define _SYNSOFT_VER_H_M3WATCOM_REVISION       1
# define _SYNSOFT_VER_H_M3WATCOM_EDIT           4
#endif /* !_SYNSOFT_DOCUMENTATION_SKIP_SECTION */

#ifdef _SYB_TRACE_INCLUDE_PATH
# pragma message(__FILE__)
#endif /* _SYB_TRACE_INCLUDE_PATH */

#if __SYNSOFT_DVS_COMPILER != __SYNSOFT_VAL_COMPILER_WATCOM
# error M3Watcom.h can only be used with Microsoft compiler. (M3Watcom.h may have been included prior to MLBase.h)
#endif /* __SYNSOFT_DVS_COMPILER != __SYNSOFT_VAL_COMPILER_WATCOM */

/* /////////////////////////////////////////////////////////////////////////////
 * Watcom-specific
 */

#if 0
#if __SYNSOFT_DVS_COMPILER_VER_WATCOM < __SYNSOFT_GEN_COMPILER_VERSION(6, 0)
#pragma warning(disable : 4663) /* Suppresses: "C++ language change: to explicitly specialize class template 'x' use the following syntax: template<> struct x<y> ..." */
#endif /* __SYNSOFT_DVS_COMPILER_VER_WATCOM < 6.0 */
#pragma warning(disable : 4097) /* Suppresses: "symbol used as synonym for class-name symbol" */
#pragma warning(disable : 4290) /* Suppresses: "C++ Exception Specification ignored" */
#pragma warning(disable : 4786) /* Suppresses: "identifier was truncated to '255' characters in the browser information" */
#ifndef __SYNSOFT_DBS_DEBUG
#if 0
#pragma warning(disable : 4055) /* Suppresses: "'conversion' : from data pointer 'type1' to function pointer 'type2'" */
#endif /* 0 */
#pragma warning(disable : 4100) /* Suppresses: "'identifier' : unreferenced formal parameter" */
#pragma warning(disable : 4127) /* Suppresses: "conditional expression is constant" */
#ifndef __STDC__
#pragma warning(disable : 4201) /* Suppresses: "nonstandard extension used : nameless struct/union" */
#pragma warning(disable : 4214) /* Suppresses: "nonstandard extension used : bit field types other than int" */
#endif /* !__STDC__ */
#pragma warning(disable : 4237) /* Suppresses: "nonstandard extension used : 'keyword' keyword is reserved for future use" */
#pragma warning(disable : 4503) /* Suppresses: "decorated name length exceeded, name was truncated" */
#pragma warning(disable : 4505) /* Suppresses: "unreferenced local function has been removed" */
#pragma warning(disable : 4514) /* Suppresses: "unreferenced inline function has been removed" */
#endif /* __SYNSOFT_DBS_DEBUG */
#pragma warning(disable : 4711) /* Suppresses: "function '...' selected for automatic inline expansion" */
#pragma warning(disable : 4786) /* Suppresses: "identifier was truncated to '255' characters in the browser information" */
#endif /* 0 */
