/* ////////////////////////////////////////////////////////////////////////////
 * File:        MWBase.h
 *
 * Purpose:     Synesis Software Windows root header.
 *
 * Created:     7th May 2000
 * Updated:     14th October 2005
 *
 * Author:      Matthew Wilson, Synesis Software Pty Ltd.
 *
 * License:     (Licensed under the Synesis Software Standard Public License)
 *
 *              Copyright 2000-2005, Synesis Software Pty Ltd.
 *
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au
 *                          http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              Redistribution and use in source and binary forms, with or
 *              without modification, are permitted provided that the following
 *              conditions are met:
 *
 *              (i) Redistributions of source code must retain the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer.
 *
 *              (ii) Redistributions in binary form must reproduce the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer in the documentation
 *              and/or other materials provided with the distribution.
 *
 *              (iii) Any derived versions of this software (howsoever modified)
 *              remain the sole property of Synesis Software.
 *
 *              (iv) Any derived versions of this software (howsoever modified)
 *              remain subject to all these conditions.
 *
 *              (v) Neither the name of Synesis Software nor the names of any
 *              subdivisions, employees or agents of Synesis Software, nor the
 *              names of any other contributors to this software may be used to
 *              endorse or promote products derived from this software without
 *              specific prior written permission.
 *
 *              This source code is provided by Synesis Software "as is" and any
 *              warranties, whether expressed or implied, including, but not
 *              limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software be liable for any direct, indirect,
 *              incidental, special, exemplary, or consequential damages
 *              (including, but not limited to, procurement of substitute goods
 *              or services; loss of use, data, or profits; or business
 *              interruption) however caused and on any theory of liability,
 *              whether in contract, strict liability, or tort (including
 *              negligence or otherwise) arising in any way out of the use of
 *              this software, even if advised of the possibility of such
 *              damage.
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef _SYNSOFT_INCL_H_MWBASE
#define _SYNSOFT_INCL_H_MWBASE

#ifndef _SYNSOFT_DOCUMENTATION_SKIP_SECTION
# define _SYNSOFT_VER_H_MWBASE_MAJOR    1
# define _SYNSOFT_VER_H_MWBASE_MINOR    12
# define _SYNSOFT_VER_H_MWBASE_REVISION 7
# define _SYNSOFT_VER_H_MWBASE_EDIT     54
#endif /* !_SYNSOFT_DOCUMENTATION_SKIP_SECTION */

/* /////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#ifndef _SYNSOFT_INCL_H_MLBASE
# include <MLBase.h>
#endif /* _SYNSOFT_INCL_H_MLBASE */
#ifdef _SYB_TRACE_INCLUDE_PATH
# pragma message(__FILE__)
#endif /* _SYB_TRACE_INCLUDE_PATH */
#if (__SYNSOFT_DVS_OS_VER & __SYNSOFT_VAL_OS_WIN) != __SYNSOFT_VAL_OS_WIN
# error Can only include MWBase.h in Windows compilations
#endif /* __SYNSOFT_VAL_OS_WIN */
#include <SWrn004u.h>
#if (__SYNSOFT_DVS_OS == __SYNSOFT_VAL_OS_WIN) && !defined(_INC_WINDOWS)
# include <windows.h>
#endif /* __SYNSOFT_VAL_OS_WIN && !_INC_WINDOWS */
#include <SWrn004o.h>

/* Intel is super pernickety about conversions, so we need to bring out the union_cast. */
#if defined(STLSOFT_COMPILER_IS_INTEL)
# ifndef STLSOFT_INCL_STLSOFT_HPP_UNION_CAST
#  include <stlsoft/union_cast.hpp>
# endif /* !STLSOFT_INCL_STLSOFT_HPP_UNION_CAST */
#endif /* STLSOFT_COMPILER_IS_INTEL */

/* /////////////////////////////////////////////////////////////////////////////
 * Compiler warnings
 */

/* Microsoft compiler warning suppression. */
#if __SYNSOFT_DVS_COMPILER_VER_MSVC >= 0x00040000
# ifndef __SYNSOFT_DBS_DEBUG
#  pragma warning(disable : 4204) /* Suppresses: "nonstandard extension used : non-constant aggregate initializer" */
# endif /* __SYNSOFT_DBS_DEBUG */
#endif /* __SYNSOFT_DVS_COMPILER_VER_MSVC >= 0x00040000 */

/* /////////////////////////////////////////////////////////////////////////////
 * Namespace
 */

__SYNSOFT_GEN_NS_START(SynesisWin)
__SYNSOFT_GEN_USING(::SynesisStd::Int)
__SYNSOFT_GEN_USING(::SynesisStd::LPInt)
__SYNSOFT_GEN_USING(::SynesisStd::RInt)
__SYNSOFT_GEN_USING(::SynesisStd::SInt32)
__SYNSOFT_GEN_USING(::SynesisStd::UInt32)
__SYNSOFT_GEN_USING(::SynesisStd::RUInt32)
__SYNSOFT_GEN_USING(::SynesisStd::ULong)
__SYNSOFT_GEN_USING(::SynesisStd::Bool)
__SYNSOFT_GEN_USING(::SynesisStd::Boolean)
__SYNSOFT_GEN_USING(::SynesisStd::DWord)
__SYNSOFT_GEN_USING(::SynesisStd::RDWord)
__SYNSOFT_GEN_USING(::SynesisStd::PCWChar)
__SYNSOFT_GEN_USING(::SynesisStd::PDWord)
__SYNSOFT_GEN_USING(::SynesisStd::Byte)
__SYNSOFT_GEN_USING(::SynesisStd::PByte)
__SYNSOFT_GEN_USING(::SynesisStd::RByte)
__SYNSOFT_GEN_USING(::SynesisStd::PCByte)
__SYNSOFT_GEN_USING(::SynesisStd::RCByte)
__SYNSOFT_GEN_USING(::SynesisStd::PVoid)
__SYNSOFT_GEN_USING(::SynesisStd::LPVoid)
__SYNSOFT_GEN_USING(::SynesisStd::PCVoid)
__SYNSOFT_GEN_USING(::SynesisStd::Size)
__SYNSOFT_GEN_USING(::SynesisStd::RSize)
__SYNSOFT_GEN_USING(::SynesisStd::Char)
__SYNSOFT_GEN_USING(::SynesisStd::AChar)
__SYNSOFT_GEN_USING(::SynesisStd::WChar)
__SYNSOFT_GEN_USING(::SynesisStd::PChar)
__SYNSOFT_GEN_USING(::SynesisStd::LPChar)
__SYNSOFT_GEN_USING(::SynesisStd::PCChar)
__SYNSOFT_GEN_USING(::SynesisStd::LPCChar)
__SYNSOFT_GEN_USING(::SynesisStd::PAChar)
__SYNSOFT_GEN_USING(::SynesisStd::LPAChar)
__SYNSOFT_GEN_USING(::SynesisStd::PWChar)
__SYNSOFT_GEN_USING(::SynesisStd::LPWChar)
__SYNSOFT_GEN_USING(::SynesisStd::PCChar)
__SYNSOFT_GEN_USING(::SynesisStd::PCAChar)
__SYNSOFT_GEN_USING(::SynesisStd::LPCAChar)
__SYNSOFT_GEN_USING(::SynesisStd::PCWChar)
__SYNSOFT_GEN_USING(::SynesisStd::LPCWChar)
__SYNSOFT_GEN_USING(::SynesisStd::LPPCAChar)
__SYNSOFT_GEN_USING(::SynesisStd::LPPCWChar)
__SYNSOFT_GEN_USING(::SynesisStd::LPPCChar)

/* ////////////////////////////////////////////////////////////////////////// */

#ifdef __SYNSOFT_DBS_DLL_BUILD
# undef __SYNSOFT_DBS_DLL_BUILD
#endif /* __SYNSOFT_DBS_DLL_BUILD */

#if (   ((__SYNSOFT_DVS_COMPILER == __SYNSOFT_VAL_COMPILER_MSVC) && defined(_WINDLL)) || \
        ((__SYNSOFT_DVS_COMPILER == __SYNSOFT_VAL_COMPILER_BORLAND) && 0))
# define __SYNSOFT_DBS_DLL_BUILD
#endif /* __SYNSOFT_DVS_COMPILER */

/* /////////////////////////////////////////////////////////////////////////////
 * Typedefs
 */

#if (__SYNSOFT_DVS_OS_VER & __SYNSOFT_VAL_OS_BITMASK) == __SYNSOFT_VAL_OS_32

typedef _mPC(FILETIME)                      LPCFILETIME;

typedef _mPC(SYSTEMTIME)                    LPCSYSTEMTIME;

#if __SYNSOFT_DVS_COMPILER_VER_MSVC == 0 || \
    __SYNSOFT_DVS_COMPILER_VER_MSVC >= __SYNSOFT_GEN_COMPILER_VERSION(4, 0)
typedef _mPC(WIN32_FILE_ATTRIBUTE_DATA)     LPCWIN32_FILE_ATTRIBUTE_DATA;
#endif /* !MSVC || MSVC >= 4 */

#endif /* __SYNSOFT_VAL_OS_32 */

#ifdef __cplusplus
inline Bool BOOL2Bool(int b)
{
    return b != 0;
}
inline int Bool2BOOL(Bool b)
{
    return b != 0;
}
inline Boolean BOOL2Boolean(int b)
{
    return b != 0;
}
inline int Boolean2BOOL(Boolean b)
{
    return b != 0;
}
#else
# define BOOL2Bool(b)               SyCastStatic(Bool, ((b) != 0))
# define Bool2BOOL(b)               SyCastStatic(BOOL, ((b) != 0))
# define BOOL2Boolean(b)            SyCastStatic(Boolean, ((b) != 0))
# define Boolean2BOOL(b)            SyCastStatic(BOOL, ((b) != 0))
#endif /* __cplusplus */

/* /////////////////////////////////////////////////////////////////////////////
 * Macro redefinitions
 */

#if defined(__cplusplus)

# undef     INVALID_HANDLE_VALUE
# if defined(STLSOFT_COMPILER_IS_INTEL)
#  define   INVALID_HANDLE_VALUE        stlsoft_ns_qual(make_union_cast)<HANDLE>(-1)
# else /* ? STLSOFT_COMPILER_IS_INTEL */
#  define   INVALID_HANDLE_VALUE        reinterpret_cast<HANDLE>(-1)
# endif /* STLSOFT_COMPILER_IS_INTEL */

# undef     MAKEINTRESOURCE
# define    MAKEINTRESOURCE(i)          reinterpret_cast<LPTSTR>(static_cast<ULONG>(static_cast<WORD>(i)))

# undef     INVALID_FILE_SIZE
# define    INVALID_FILE_SIZE           static_cast<DWORD>(0xFFFFFFFF)

# undef     SRCCOPY
# undef     SRCPAINT
# undef     SRCAND
# undef     SRCINVERT
# undef     SRCERASE
# undef     NOTSRCCOPY
# undef     NOTSRCERASE
# undef     MERGECOPY
# undef     MERGEPAINT
# undef     PATCOPY
# undef     PATPAINT
# undef     PATINVERT
# undef     DSTINVERT
# undef     BLACKNESS
# undef     WHITENESS
# define    SRCCOPY             static_cast<DWORD>(0x00CC0020) /* dest = source                   */
# define    SRCPAINT            static_cast<DWORD>(0x00EE0086) /* dest = source OR dest           */
# define    SRCAND              static_cast<DWORD>(0x008800C6) /* dest = source AND dest          */
# define    SRCINVERT           static_cast<DWORD>(0x00660046) /* dest = source XOR dest          */
# define    SRCERASE            static_cast<DWORD>(0x00440328) /* dest = source AND (NOT dest )   */
# define    NOTSRCCOPY          static_cast<DWORD>(0x00330008) /* dest = (NOT source)             */
# define    NOTSRCERASE         static_cast<DWORD>(0x001100A6) /* dest = (NOT src) AND (NOT dest) */
# define    MERGECOPY           static_cast<DWORD>(0x00C000CA) /* dest = (source AND pattern)     */
# define    MERGEPAINT          static_cast<DWORD>(0x00BB0226) /* dest = (NOT source) OR dest     */
# define    PATCOPY             static_cast<DWORD>(0x00F00021) /* dest = pattern                  */
# define    PATPAINT            static_cast<DWORD>(0x00FB0A09) /* dest = DPSnoo                   */
# define    PATINVERT           static_cast<DWORD>(0x005A0049) /* dest = pattern XOR dest         */
# define    DSTINVERT           static_cast<DWORD>(0x00550009) /* dest = (NOT dest)               */
# define    BLACKNESS           static_cast<DWORD>(0x00000042) /* dest = BLACK                    */
# define    WHITENESS           static_cast<DWORD>(0x00FF0062) /* dest = WHITE                    */


# if !defined(__SYNSOFT_DBS_DEBUG) && \
     __SYNSOFT_DVS_COMPILER_VER_DMC >= __SYNSOFT_GEN_COMPILER_VERSION(8, 29)

#  undef    LOBYTE
#  undef    HIBYTE
#  undef    LOWORD
#  undef    HIWORD
#  undef    MAKEWORD
#  undef    MAKELONG
#  define   LOBYTE(w)               (static_cast<BYTE>(w))
#  define   HIBYTE(w)               (static_cast<BYTE>((static_cast<WORD>(w) >> 8) & 0xFF))
#  define   LOWORD(l)               (static_cast<WORD>(l))
#  define   HIWORD(l)               (static_cast<WORD>((static_cast<DWORD>(l) >> 16) & 0xFFFF))
#  define   MAKEWORD(a, b)          (static_cast<WORD>((static_cast<BYTE>(a)) | (static_cast<WORD>(static_cast<BYTE>(b))) << 8))
#  define   MAKELONG(a, b)          (static_cast<LONG>((static_cast<WORD>(a)) | (static_cast<DWORD>(static_cast<WORD>(b))) << 16))


#  undef    MAKELANGID
#  undef    PRIMARYLANGID
#  undef    SUBLANGID
#  define   MAKELANGID(p, s)        (((static_cast<WORD>(s)) << 10) | static_cast<WORD>(p))
#  define   PRIMARYLANGID(lgid)     (static_cast<WORD>(lgid) & 0x3ff)
#  define   SUBLANGID(lgid)         (static_cast<WORD>(lgid) >> 10)


#  undef    MAKELCID
#  undef    LANGIDFROMLCID
#  undef    SORTIDFROMLCID
#  define   MAKELCID(lgid, srtid)   (static_cast<DWORD>(((static_cast<DWORD>(static_cast<WORD>(srtid))) << 16) | (static_cast<DWORD>(static_cast<WORD>(lgid)))))
#  define   LANGIDFROMLCID(lcid)    (static_cast<WORD>(lcid))
#  define   SORTIDFROMLCID(lcid)    (static_cast<WORD>(((static_cast<DWORD>(lcid)) & NLS_VALID_LOCALE_MASK) >> 16))

# endif /* !debug && DMC++ */

#endif /* __cplusplus */

/* ////////////////////////////////////////////////////////////////////////// */

#ifdef __cplusplus

/* /////////////////////////////////////////////////////////////////////////////
 * Utility functions
 */


/* CloseHandleSetNull
 *
 * Closes a handle, and sets its value to NULL
 */

#ifdef __SYNSOFT_DBS_API_WIN32
inline Bool CloseHandleSetNull(HANDLE &h)
{
    return ::CloseHandle(h) ? (h = SyCastStatic(HANDLE, 0), true) : false;
}
#endif /* __SYNSOFT_DBS_API_WIN32 */

/* DuplicateLocalHandle()
 *
 * Duplicates a handle. Both the handle and the duplicate are within the context
 * of the current process.
 */
#ifdef __SYNSOFT_DBS_API_WIN32
inline Boolean DuplicateLocalHandle(HANDLE h, HANDLE &hDup)
{
    return BOOL2Boolean(::DuplicateHandle(::GetCurrentProcess(), h, ::GetCurrentProcess(), &hDup, 0, false, DUPLICATE_SAME_ACCESS));
}
#endif /* __SYNSOFT_DBS_API_WIN32 */

/* GetNumberOfProcessors()
 *
 * Returns the number of processors.
 */

inline UInt32 GetNumberOfProcessors()
{
#ifdef __SYNSOFT_DBS_API_WIN32
    SYSTEM_INFO si;

    ::GetSystemInfo(&si);

    return si.dwNumberOfProcessors;
#elif (__SYNSOFT_DVS_OS_VER & (__SYNSOFT_VAL_OS_WIN  | __SYNSOFT_VAL_OS_BITMASK)) == (__SYNSOFT_VAL_OS_WIN  | __SYNSOFT_VAL_OS_16)
    return 1;
#else
# error This function is only implemented for 16 and 32-bit Windows operating systems
#endif /* __SYNSOFT_DBS_API_WIN32 */
}

/* HWND HwndFromWrapper(Type t)
 *
 * The various overrides of this class are used to convert from an instance of a
 * window wrapper class, to the underlying HWND.
 */

inline HWND HwndFromWrapper(HWND hwnd)
{
    return hwnd;
}

#ifdef __ATLWIN_H__

/* CWindow is not qualified here, since all ATL versions thus far either
 * suppress namespacing, or have a using directive!
 */

inline HWND HwndFromWrapper(CWindow *pwnd)
{
    return (pwnd != NULL) ? pwnd->m_hWnd : NULL;
}

inline HWND HwndFromWrapper(CWindow &wnd)
{
    return wnd.m_hWnd;
}

#endif /* __ATLWIN_H__ */

#ifdef __AFX_H__

inline HWND HwndFromWrapper(CWnd *pwnd)
{
    return pwnd->GetSafeHwnd();
}

inline HWND HwndFromWrapper(CWnd &wnd)
{
    return wnd.m_hWnd;
}

#endif /* __AFX_H__ */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* __cplusplus */

/* ////////////////////////////////////////////////////////////////////////// */

__SYNSOFT_GEN_NS_END_DECL(SynesisWin)

__SYNSOFT_GEN_USING(::SynesisWin::BOOL2Bool)
__SYNSOFT_GEN_USING(::SynesisWin::Bool2BOOL)

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* _SYNSOFT_INCL_H_MWBASE */

/* ////////////////////////////////////////////////////////////////////////// */
