/* /////////////////////////////////////////////////////////////////////////////
 * File:        SLBasUDf.h
 *
 * Purpose:     Undefines all the symbols used in SLBase.h & SLCpp.h
 *
 * Created      5th February 2002
 * Updated:     18th February 2005
 *
 * Author:      Matthew Wilson, Synesis Software Pty Ltd.
 *
 * License:     (Licensed under the Synesis Software Standard Public License)
 *
 *              Copyright 2002, Synesis Software Pty Ltd.
 *
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au
 *                          http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              Redistribution and use in source and binary forms, with or
 *              without modification, are permitted provided that the following
 *              conditions are met:
 *
 *              (i) Redistributions of source code must retain the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer.
 *
 *              (ii) Redistributions in binary form must reproduce the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer in the documentation
 *              and/or other materials provided with the distribution.
 *
 *              (iii) Any derived versions of this software (howsoever modified)
 *              remain the sole property of Synesis Software.
 *
 *              (iv) Any derived versions of this software (howsoever modified)
 *              remain subject to all these conditions.
 *
 *              (v) Neither the name of Synesis Software nor the names of any
 *              subdivisions, employees or agents of Synesis Software, nor the
 *              names of any other contributors to this software may be used to
 *              endorse or promote products derived from this software without
 *              specific prior written permission.
 *
 *              This source code is provided by Synesis Software "as is" and any
 *              warranties, whether expressed or implied, including, but not
 *              limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software be liable for any direct, indirect,
 *              incidental, special, exemplary, or consequential damages
 *              (including, but not limited to, procurement of substitute goods
 *              or services; loss of use, data, or profits; or business
 *              interruption) however caused and on any theory of liability,
 *              whether in contract, strict liability, or tort (including
 *              negligence or otherwise) arising in any way out of the use of
 *              this software, even if advised of the possibility of such
 *              damage.
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef _SYNSOFT_INCL_H_SLBASUDF
#define _SYNSOFT_INCL_H_SLBASUDF

#ifndef _SYNSOFT_DOCUMENTATION_SKIP_SECTION
# define _SYNSOFT_VER_H_SLBASUDF_MAJOR          1
# define _SYNSOFT_VER_H_SLBASUDF_MINOR          1
# define _SYNSOFT_VER_H_SLBASUDF_REVISION       3
# define _SYNSOFT_VER_H_SLBASUDF_EDIT           14
#endif /* !_SYNSOFT_DOCUMENTATION_SKIP_SECTION */

#ifdef _SYB_NO_SLBASE_SYMBOL_UNDEF
# error This file cannot (and, by default, will not) be included when _SYB_NO_SLBASE_SYMBOL_UNDEF is defined
#endif /* _SYB_NO_SLBASE_SYMBOL_UNDEF */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 1. Compiler messaging
 */

/* These symbols are undefined within SLBase.h itself. */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 2. compiler discrimination
 */

#ifdef __SYNSOFT_DVS_COMPILER
# undef __SYNSOFT_DVS_COMPILER
#endif /* __SYNSOFT_DVS_COMPILER */

#ifdef __SYNSOFT_DVS_COMPILER_VER
# undef __SYNSOFT_DVS_COMPILER_VER
#endif /* __SYNSOFT_DVS_COMPILER_VER */

#ifdef __SYNSOFT_GEN_COMPILER_VERSION
# undef __SYNSOFT_GEN_COMPILER_VERSION
#endif /* __SYNSOFT_GEN_COMPILER_VERSION */

#ifdef __SYNSOFT_DVS_COMPILER_VER_BORLAND
# undef __SYNSOFT_DVS_COMPILER_VER_BORLAND
#endif /* __SYNSOFT_DVS_COMPILER_VER_BORLAND */

#ifdef __SYNSOFT_DVS_COMPILER_VER_DECC
# undef __SYNSOFT_DVS_COMPILER_VER_DECC
#endif /* __SYNSOFT_DVS_COMPILER_VER_DECC */

#ifdef __SYNSOFT_DVS_COMPILER_VER_DECCXX
# undef __SYNSOFT_DVS_COMPILER_VER_DECCXX
#endif /* __SYNSOFT_DVS_COMPILER_VER_DECCXX */

#ifdef __SYNSOFT_DVS_COMPILER_VER_GNUC
# undef __SYNSOFT_DVS_COMPILER_VER_GNUC
#endif /* __SYNSOFT_DVS_COMPILER_VER_GNUC */

#ifdef __SYNSOFT_DVS_COMPILER_VER_MSVC
# undef __SYNSOFT_DVS_COMPILER_VER_MSVC
#endif /* __SYNSOFT_DVS_COMPILER_VER_MSVC */

#ifdef __SYNSOFT_DVS_COMPILER_VER_WATCOM
# undef __SYNSOFT_DVS_COMPILER_VER_WATCOM
#endif /* __SYNSOFT_DVS_COMPILER_VER_WATCOM */

#ifdef __SYNSOFT_DVS_COMPILER_VER_XLC
# undef __SYNSOFT_DVS_COMPILER_VER_XLC
#endif /* __SYNSOFT_DVS_COMPILER_VER_XLC */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 3. architecture discrimination
 */

#ifdef __SYNSOFT_DVS_ARCHITECTURE
# undef __SYNSOFT_DVS_ARCHITECTURE
#endif /* __SYNSOFT_DVS_ARCHITECTURE */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 3.1. byte-order discrimination
 */

#ifdef __SYNSOFT_DVS_ARCHITECTURE_BYTEORDER
# undef __SYNSOFT_DVS_ARCHITECTURE_BYTEORDER
#endif /* __SYNSOFT_DVS_ARCHITECTURE_BYTEORDER */

#ifdef __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_BIGENDIAN
# undef __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_BIGENDIAN
#endif /* __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_BIGENDIAN */

#ifdef __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_LITTLEENDIAN
# undef __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_LITTLEENDIAN
#endif /* __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_LITTLEENDIAN */

#ifdef __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_MIDDLEENDIAN
# undef __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_MIDDLEENDIAN
#endif /* __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_MIDDLEENDIAN */

#ifdef __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_AMBIENDIAN
# undef __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_AMBIENDIAN
#endif /* __SYNSOFT_DBS_ARCHITECTURE_BYTEORDER_AMBIENDIAN */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 4. operating system discrimination
 */

#ifdef __SYNSOFT_DVS_OS_BITSIZE
# undef __SYNSOFT_DVS_OS_BITSIZE
#endif /* __SYNSOFT_DVS_OS_BITSIZE */

#ifdef __SYNSOFT_DVS_OS
# undef __SYNSOFT_DVS_OS
#endif /* __SYNSOFT_DVS_OS */

#ifdef __SYNSOFT_DVS_OS_VER
# undef __SYNSOFT_DVS_OS_VER
#endif /* __SYNSOFT_DVS_OS_VER */

#ifdef __SYNSOFT_DBS_UNIX_VARIANT_OSF
# undef __SYNSOFT_DBS_UNIX_VARIANT_OSF
#endif /* __SYNSOFT_DBS_UNIX_VARIANT_OSF */

#ifdef __SYNSOFT_DBS_UNIX_VARIANT_SOLARIS
# undef __SYNSOFT_DBS_UNIX_VARIANT_SOLARIS
#endif /* __SYNSOFT_DBS_UNIX_VARIANT_SOLARIS */

#ifdef __SYNSOFT_DBS_UNIX_VARIANT_LINUX
# undef __SYNSOFT_DBS_UNIX_VARIANT_LINUX
#endif /* __SYNSOFT_DBS_UNIX_VARIANT_LINUX */

#ifdef __SYNSOFT_DBS_UNIX_VARIANT_HPUX
# undef __SYNSOFT_DBS_UNIX_VARIANT_HPUX
#endif /* __SYNSOFT_DBS_UNIX_VARIANT_HPUX */

#ifdef __SYNSOFT_DBS_UNIX_VARIANT_AIX
# undef __SYNSOFT_DBS_UNIX_VARIANT_AIX
#endif /* __SYNSOFT_DBS_UNIX_VARIANT_AIX */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 5. function specifications
 */

/* /////////////////////////////////////////////////////////////////////////////
 * 5.1. linkage class
 */

#ifdef __SYNSOFT_MOD_LINKAGE_NULL
# undef __SYNSOFT_MOD_LINKAGE_NULL
#endif /* __SYNSOFT_MOD_LINKAGE_NULL */

#ifdef __SYNSOFT_MOD_LINKAGE_C
# undef __SYNSOFT_MOD_LINKAGE_C
#endif /* __SYNSOFT_MOD_LINKAGE_C */

#ifdef __SYNSOFT_GEN_STARTLINKAGE_C
# undef __SYNSOFT_GEN_STARTLINKAGE_C
#endif /* __SYNSOFT_GEN_STARTLINKAGE_C */

#ifdef __SYNSOFT_GEN_ENDLINKAGE_C
# undef __SYNSOFT_GEN_ENDLINKAGE_C
#endif /* __SYNSOFT_GEN_ENDLINKAGE_C */

#ifdef __SYNSOFT_MOD_LINKAGE_CPP
# undef __SYNSOFT_MOD_LINKAGE_CPP
#endif /* __SYNSOFT_MOD_LINKAGE_CPP */

#ifdef __SYNSOFT_GEN_STARTLINKAGE_CPP
# undef __SYNSOFT_GEN_STARTLINKAGE_CPP
#endif /* __SYNSOFT_GEN_STARTLINKAGE_CPP */

#ifdef __SYNSOFT_GEN_ENDLINKAGE_CPP
# undef __SYNSOFT_GEN_ENDLINKAGE_CPP
#endif /* __SYNSOFT_GEN_ENDLINKAGE_CPP */

/* /////////////////////////////////////////////////////////////////////////////
 * 5.2. storage class
 */

#ifdef __SYNSOFT_MOD_STGCLASS_NULL
# undef __SYNSOFT_MOD_STGCLASS_NULL
#endif /* __SYNSOFT_MOD_STGCLASS_NULL */

#ifdef __SYNSOFT_MOD_STGCLASS_VIRTUAL
# undef __SYNSOFT_MOD_STGCLASS_VIRTUAL
#endif /* __SYNSOFT_MOD_STGCLASS_VIRTUAL */

#ifdef __SYNSOFT_MOD_STGCLASS_STATIC
# undef __SYNSOFT_MOD_STGCLASS_STATIC
#endif /* __SYNSOFT_MOD_STGCLASS_STATIC */

#ifdef __SYNSOFT_MOD_STGCLASS_IMPORT
# undef __SYNSOFT_MOD_STGCLASS_IMPORT
#endif /* __SYNSOFT_MOD_STGCLASS_IMPORT */

#ifdef __SYNSOFT_MOD_STGCLASS_EXPORT
# undef __SYNSOFT_MOD_STGCLASS_EXPORT
#endif /* __SYNSOFT_MOD_STGCLASS_EXPORT */

/* /////////////////////////////////////////////////////////////////////////////
 * 5.3. memory model
 */

#ifdef __SYNSOFT_MOD_MEMMODEL_NULL
# undef __SYNSOFT_MOD_MEMMODEL_NULL
#endif /* __SYNSOFT_MOD_MEMMODEL_NULL */

#ifdef __SYNSOFT_MOD_MEMMODEL_NEAR
# undef __SYNSOFT_MOD_MEMMODEL_NEAR
#endif /* __SYNSOFT_MOD_MEMMODEL_NEAR */

#ifdef __SYNSOFT_MOD_MEMMODEL_FAR
# undef __SYNSOFT_MOD_MEMMODEL_FAR
#endif /* __SYNSOFT_MOD_MEMMODEL_FAR */

#ifdef __SYNSOFT_MOD_MEMMODEL_HUGE
# undef __SYNSOFT_MOD_MEMMODEL_HUGE
#endif /* __SYNSOFT_MOD_MEMMODEL_HUGE */

/* /////////////////////////////////////////////////////////////////////////////
 * 5.4. calling convention
 */

#ifdef __SYNSOFT_MOD_CALLCONV_NULL
# undef __SYNSOFT_MOD_CALLCONV_NULL
#endif /* __SYNSOFT_MOD_CALLCONV_NULL */

#ifdef __SYNSOFT_MOD_CALLCONV_CDECL
# undef __SYNSOFT_MOD_CALLCONV_CDECL
#endif /* __SYNSOFT_MOD_CALLCONV_CDECL */

#ifdef __SYNSOFT_MOD_CALLCONV_STDCALL
# undef __SYNSOFT_MOD_CALLCONV_STDCALL
#endif /* __SYNSOFT_MOD_CALLCONV_STDCALL */

#ifdef __SYNSOFT_MOD_CALLCONV_FASTCALL
# undef __SYNSOFT_MOD_CALLCONV_FASTCALL
#endif /* __SYNSOFT_MOD_CALLCONV_FASTCALL */

#ifdef __SYNSOFT_MOD_CALLCONV_DEFAULT
# undef __SYNSOFT_MOD_CALLCONV_DEFAULT
#endif /* __SYNSOFT_MOD_CALLCONV_DEFAULT */

#ifdef __SYNSOFT_MOD_CALLCONV_VDECL
# undef __SYNSOFT_MOD_CALLCONV_VDECL
#endif /* __SYNSOFT_MOD_CALLCONV_VDECL */

#ifdef __SYNSOFT_MOD_CALLCONV_STATDECL
# undef __SYNSOFT_MOD_CALLCONV_STATDECL
#endif /* __SYNSOFT_MOD_CALLCONV_STATDECL */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 6. Casting
 */

#ifdef __SYNSOFT_DBS_CAST_OPERATOR_SUPPORT
# undef __SYNSOFT_DBS_CAST_OPERATOR_SUPPORT
#endif /* __SYNSOFT_DBS_CAST_OPERATOR_SUPPORT */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 7. namespace support discrimination
 */

#ifdef __SYNSOFT_DBS_NAMESPACE_SUPPORT
# undef __SYNSOFT_DBS_NAMESPACE_SUPPORT
#endif /* __SYNSOFT_DBS_NAMESPACE_SUPPORT */

#ifdef __SYNSOFT_DBS_NAMESPACE_SYNESIS
# undef __SYNSOFT_DBS_NAMESPACE_SYNESIS
#endif /* __SYNSOFT_DBS_NAMESPACE_SYNESIS */

#ifdef __SYNSOFT_GEN_NS_START
# undef __SYNSOFT_GEN_NS_START
#endif /* __SYNSOFT_GEN_NS_START */

#ifdef __SYNSOFT_GEN_NS_END
# undef __SYNSOFT_GEN_NS_END
#endif /* __SYNSOFT_GEN_NS_END */

#ifdef __SYNSOFT_GEN_NS_END_DECL
# undef __SYNSOFT_GEN_NS_END_DECL
#endif /* __SYNSOFT_GEN_NS_END_DECL */

#ifdef __SYNSOFT_GEN_NS_END_IMPL
# undef __SYNSOFT_GEN_NS_END_IMPL
#endif /* __SYNSOFT_GEN_NS_END_IMPL */

#ifdef __SYNSOFT_GEN_NS_ANON_START
# undef __SYNSOFT_GEN_NS_ANON_START
#endif /* __SYNSOFT_GEN_NS_ANON_START */

#ifdef __SYNSOFT_GEN_NS_ANON_END
# undef __SYNSOFT_GEN_NS_ANON_END
#endif /* __SYNSOFT_GEN_NS_ANON_END */

#ifdef __SYNSOFT_GEN_NS_USING
# undef __SYNSOFT_GEN_NS_USING
#endif /* __SYNSOFT_GEN_NS_USING */

#ifdef __SYNSOFT_GEN_NS_QUAL
# undef __SYNSOFT_GEN_NS_QUAL
#endif /* __SYNSOFT_GEN_NS_QUAL */

#ifdef __SYNSOFT_GEN_NS_QUAL_OR_GLBL
# undef __SYNSOFT_GEN_NS_QUAL_OR_GLBL
#endif /* __SYNSOFT_GEN_NS_QUAL_OR_GLBL */

#ifdef __SYNSOFT_GEN_USING
# undef __SYNSOFT_GEN_USING
#endif /* __SYNSOFT_GEN_USING */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 8. multithreading support discrimination
 */

#ifdef __SYNSOFT_DBS_MULTITHREADED_PLATFORM
# undef __SYNSOFT_DBS_MULTITHREADED_PLATFORM
#endif /* __SYNSOFT_DBS_MULTITHREADED_PLATFORM */

#ifdef __SYNSOFT_DBS_MULTITHREADED_SUPPORT
# undef __SYNSOFT_DBS_MULTITHREADED_SUPPORT
#endif /* __SYNSOFT_DBS_MULTITHREADED_SUPPORT */

#ifdef __SYNSOFT_MOD_DECLSPEC_THREADLOCAL
# undef __SYNSOFT_MOD_DECLSPEC_THREADLOCAL
#endif /* __SYNSOFT_MOD_DECLSPEC_THREADLOCAL */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 9. debugging support
 */

#ifdef __SYNSOFT_DBS_DEBUG
# undef __SYNSOFT_DBS_DEBUG
#endif /* __SYNSOFT_DBS_DEBUG */

#ifdef __SYNSOFT_DBS_NDEBUG
# undef __SYNSOFT_DBS_NDEBUG
#endif /* __SYNSOFT_DBS_NDEBUG */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 11. API discrimination
 */

#ifdef __SYNSOFT_DBS_API_WIN32
# undef __SYNSOFT_DBS_API_WIN32
#endif /* __SYNSOFT_DBS_API_WIN32 */

#ifdef __SYNSOFT_DBS_API_PTHREADS
# undef __SYNSOFT_DBS_API_PTHREADS
#endif /* __SYNSOFT_DBS_API_PTHREADS */

#ifdef __SYNSOFT_DBS_API_COM
# undef __SYNSOFT_DBS_API_COM
#endif /* __SYNSOFT_DBS_API_COM */

#ifdef __SYNSOFT_DBS_API_CORBA
# undef __SYNSOFT_DBS_API_CORBA
#endif /* __SYNSOFT_DBS_API_CORBA */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 12. C-language feature discrimination
 */

#ifdef __SYNSOFT_DBS_STDC
# undef __SYNSOFT_DBS_STDC
#endif /* __SYNSOFT_DBS_STDC */

#ifdef __SYNSOFT_DBS_CINLINE_SUPPORT
# undef __SYNSOFT_DBS_CINLINE_SUPPORT
#endif /* __SYNSOFT_DBS_CINLINE_SUPPORT */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 13. C & C++-language feature discrimination
 */

#ifdef __SYNSOFT_DBS_INLINE_SUPPORT
# undef __SYNSOFT_DBS_INLINE_SUPPORT
#endif /* __SYNSOFT_DBS_INLINE_SUPPORT */

#ifdef __SYNSOFT_DBS_IMPLEMENTATION_PARAMETERS_CONST_SUPPORT
# undef __SYNSOFT_DBS_IMPLEMENTATION_PARAMETERS_CONST_SUPPORT
#endif /* __SYNSOFT_DBS_IMPLEMENTATION_PARAMETERS_CONST_SUPPORT */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 14. C++-language feature discrimination
 */

#ifdef __SYNSOFT_DBS_CCOMPATIBLE_VTABLE_LAYOUT
# undef __SYNSOFT_DBS_CCOMPATIBLE_VTABLE_LAYOUT
#endif /* __SYNSOFT_DBS_CCOMPATIBLE_VTABLE_LAYOUT */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 15. type support discrimination
 */

#ifdef __SYNSOFT_GEN_char_t
# undef __SYNSOFT_GEN_char_t
#endif /* __SYNSOFT_GEN_char_t */
#ifdef __SYNSOFT_GEN_short_t
# undef __SYNSOFT_GEN_short_t
#endif /* __SYNSOFT_GEN_short_t */
#ifdef __SYNSOFT_GEN_int_t
# undef __SYNSOFT_GEN_int_t
#endif /* __SYNSOFT_GEN_int_t */
#ifdef __SYNSOFT_GEN_long_t
# undef __SYNSOFT_GEN_long_t
#endif /* __SYNSOFT_GEN_long_t */
#ifdef __SYNSOFT_GEN_long_long_t
# undef __SYNSOFT_GEN_long_long_t
#endif /* __SYNSOFT_GEN_long_long_t */
#ifdef __SYNSOFT_GEN_float_t
# undef __SYNSOFT_GEN_float_t
#endif /* __SYNSOFT_GEN_float_t */
#ifdef __SYNSOFT_GEN_double_t
# undef __SYNSOFT_GEN_double_t
#endif /* __SYNSOFT_GEN_double_t */
#ifdef __SYNSOFT_GEN_long_double_t
# undef __SYNSOFT_GEN_long_double_t
#endif /* __SYNSOFT_GEN_long_double_t */


/* 8-bit. */
#ifdef __SYNSOFT_DBS_UINT8_SUPPORT
# undef __SYNSOFT_DBS_UINT8_SUPPORT
#endif /* __SYNSOFT_DBS_UINT8_SUPPORT */
#ifdef __SYNSOFT_DBS_SINT8_SUPPORT
# undef __SYNSOFT_DBS_SINT8_SUPPORT
#endif /* __SYNSOFT_DBS_SINT8_SUPPORT */
#ifdef __SYNSOFT_DBS_INT8_SUPPORT
# undef __SYNSOFT_DBS_INT8_SUPPORT
#endif /* __SYNSOFT_DBS_INT8_SUPPORT */

/* 16-bit. */
#ifdef __SYNSOFT_DBS_UINT16_SUPPORT
# undef __SYNSOFT_DBS_UINT16_SUPPORT
#endif /* __SYNSOFT_DBS_UINT16_SUPPORT */
#ifdef __SYNSOFT_DBS_SINT16_SUPPORT
# undef __SYNSOFT_DBS_SINT16_SUPPORT
#endif /* __SYNSOFT_DBS_SINT16_SUPPORT */
#ifdef __SYNSOFT_DBS_INT16_SUPPORT
# undef __SYNSOFT_DBS_INT16_SUPPORT
#endif /* __SYNSOFT_DBS_INT16_SUPPORT */

/* 32-bit. */
#ifdef __SYNSOFT_DBS_UINT32_SUPPORT
# undef __SYNSOFT_DBS_UINT32_SUPPORT
#endif /* __SYNSOFT_DBS_UINT32_SUPPORT */
#ifdef __SYNSOFT_DBS_SINT32_SUPPORT
# undef __SYNSOFT_DBS_SINT32_SUPPORT
#endif /* __SYNSOFT_DBS_SINT32_SUPPORT */
#ifdef __SYNSOFT_DBS_INT32_SUPPORT
# undef __SYNSOFT_DBS_INT32_SUPPORT
#endif /* __SYNSOFT_DBS_INT32_SUPPORT */

/* 64-bit. */
#ifdef __SYNSOFT_DBS_UINT64_SUPPORT
# undef __SYNSOFT_DBS_UINT64_SUPPORT
#endif /* __SYNSOFT_DBS_UINT64_SUPPORT */
#ifdef __SYNSOFT_DBS_SINT64_SUPPORT
# undef __SYNSOFT_DBS_SINT64_SUPPORT
#endif /* __SYNSOFT_DBS_SINT64_SUPPORT */
#ifdef __SYNSOFT_DBS_INT64_SUPPORT
# undef __SYNSOFT_DBS_INT64_SUPPORT
#endif /* __SYNSOFT_DBS_INT64_SUPPORT */

/* 128-bit. */
#ifdef __SYNSOFT_DBS_UINT128_SUPPORT
# undef __SYNSOFT_DBS_UINT128_SUPPORT
#endif /* __SYNSOFT_DBS_UINT128_SUPPORT */
#ifdef __SYNSOFT_DBS_SINT128_SUPPORT
# undef __SYNSOFT_DBS_SINT128_SUPPORT
#endif /* __SYNSOFT_DBS_SINT128_SUPPORT */
#ifdef __SYNSOFT_DBS_INT128_SUPPORT
# undef __SYNSOFT_DBS_INT128_SUPPORT
#endif /* __SYNSOFT_DBS_INT128_SUPPORT */


/* Byte. */
#ifdef __SYNSOFT_DBS_UBYTE_SUPPORT
# undef __SYNSOFT_DBS_UBYTE_SUPPORT
#endif /* __SYNSOFT_DBS_UBYTE_SUPPORT */
#ifdef __SYNSOFT_DBS_SBYTE_SUPPORT
# undef __SYNSOFT_DBS_SBYTE_SUPPORT
#endif /* __SYNSOFT_DBS_SBYTE_SUPPORT */
#ifdef __SYNSOFT_DBS_BYTE_SUPPORT
# undef __SYNSOFT_DBS_BYTE_SUPPORT
#endif /* __SYNSOFT_DBS_BYTE_SUPPORT */

/* Short. */
#ifdef __SYNSOFT_DBS_USHORT_SUPPORT
# undef __SYNSOFT_DBS_USHORT_SUPPORT
#endif /* __SYNSOFT_DBS_USHORT_SUPPORT */
#ifdef __SYNSOFT_DBS_SSHORT_SUPPORT
# undef __SYNSOFT_DBS_SSHORT_SUPPORT
#endif /* __SYNSOFT_DBS_SSHORT_SUPPORT */
#ifdef __SYNSOFT_DBS_SHORT_SUPPORT
# undef __SYNSOFT_DBS_SHORT_SUPPORT
#endif /* __SYNSOFT_DBS_SHORT_SUPPORT */

/* Int. */
#ifdef __SYNSOFT_DBS_UINT_SUPPORT
# undef __SYNSOFT_DBS_UINT_SUPPORT
#endif /* __SYNSOFT_DBS_UINT_SUPPORT */
#ifdef __SYNSOFT_DBS_SINT_SUPPORT
# undef __SYNSOFT_DBS_SINT_SUPPORT
#endif /* __SYNSOFT_DBS_SINT_SUPPORT */
#ifdef __SYNSOFT_DBS_INT_SUPPORT
# undef __SYNSOFT_DBS_INT_SUPPORT
#endif /* __SYNSOFT_DBS_INT_SUPPORT */

/* Long. */
#ifdef __SYNSOFT_DBS_ULONG_SUPPORT
# undef __SYNSOFT_DBS_ULONG_SUPPORT
#endif /* __SYNSOFT_DBS_ULONG_SUPPORT */
#ifdef __SYNSOFT_DBS_SLONG_SUPPORT
# undef __SYNSOFT_DBS_SLONG_SUPPORT
#endif /* __SYNSOFT_DBS_SLONG_SUPPORT */
#ifdef __SYNSOFT_DBS_LONG_SUPPORT
# undef __SYNSOFT_DBS_LONG_SUPPORT
#endif /* __SYNSOFT_DBS_LONG_SUPPORT */

/* Long Long. */
#ifdef __SYNSOFT_DBS_ULLONG_SUPPORT
# undef __SYNSOFT_DBS_ULLONG_SUPPORT
#endif /* __SYNSOFT_DBS_ULLONG_SUPPORT */
#ifdef __SYNSOFT_DBS_SLLONG_SUPPORT
# undef __SYNSOFT_DBS_SLLONG_SUPPORT
#endif /* __SYNSOFT_DBS_SLLONG_SUPPORT */
#ifdef __SYNSOFT_DBS_LLONG_SUPPORT
# undef __SYNSOFT_DBS_LLONG_SUPPORT
#endif /* __SYNSOFT_DBS_LLONG_SUPPORT */

/* Platform-pointer - sized int. */
#ifdef __SYNSOFT_DBS_UINTP_SUPPORT
# undef __SYNSOFT_DBS_UINTP_SUPPORT
#endif /* __SYNSOFT_DBS_UINTP_SUPPORT */
#ifdef __SYNSOFT_DBS_SINTP_SUPPORT
# undef __SYNSOFT_DBS_SINTP_SUPPORT
#endif /* __SYNSOFT_DBS_SINTP_SUPPORT */
#ifdef __SYNSOFT_DBS_INTP_SUPPORT
# undef __SYNSOFT_DBS_INTP_SUPPORT
#endif /* __SYNSOFT_DBS_INTP_SUPPORT */


/* Floating point. */
#ifdef __SYNSOFT_DBS_FLOAT_SUPPORT
# undef __SYNSOFT_DBS_FLOAT_SUPPORT
#endif /* __SYNSOFT_DBS_FLOAT_SUPPORT */
#ifdef __SYNSOFT_DBS_DOUBLE_SUPPORT
# undef __SYNSOFT_DBS_DOUBLE_SUPPORT
#endif /* __SYNSOFT_DBS_DOUBLE_SUPPORT */
#ifdef __SYNSOFT_DBS_LDOUBLE_SUPPORT
# undef __SYNSOFT_DBS_LDOUBLE_SUPPORT
#endif /* __SYNSOFT_GEN_LDOUBLE_SUPPORT */


/* 8-bit. */
#ifdef __SYNSOFT_GEN_UINT8_T
# undef __SYNSOFT_GEN_UINT8_T
#endif /* __SYNSOFT_GEN_UINT8_T */
#ifdef __SYNSOFT_GEN_SINT8_T
# undef __SYNSOFT_GEN_SINT8_T
#endif /* __SYNSOFT_GEN_SINT8_T */
#ifdef __SYNSOFT_GEN_INT8_T
# undef __SYNSOFT_GEN_INT8_T
#endif /* __SYNSOFT_GEN_INT8_T */

/* 16-bit. */
#ifdef __SYNSOFT_GEN_UINT16_T
# undef __SYNSOFT_GEN_UINT16_T
#endif /* __SYNSOFT_GEN_UINT16_T */
#ifdef __SYNSOFT_GEN_SINT16_T
# undef __SYNSOFT_GEN_SINT16_T
#endif /* __SYNSOFT_GEN_SINT16_T */
#ifdef __SYNSOFT_GEN_INT16_T
# undef __SYNSOFT_GEN_INT16_T
#endif /* __SYNSOFT_GEN_INT16_T */

/* 32-bit. */
#ifdef __SYNSOFT_GEN_UINT32_T
# undef __SYNSOFT_GEN_UINT32_T
#endif /* __SYNSOFT_GEN_UINT32_T */
#ifdef __SYNSOFT_GEN_SINT32_T
# undef __SYNSOFT_GEN_SINT32_T
#endif /* __SYNSOFT_GEN_SINT32_T */
#ifdef __SYNSOFT_GEN_INT32_T
# undef __SYNSOFT_GEN_INT32_T
#endif /* __SYNSOFT_GEN_INT32_T */

/* 64-bit. */
#ifdef __SYNSOFT_GEN_UINT64_T
# undef __SYNSOFT_GEN_UINT64_T
#endif /* __SYNSOFT_GEN_UINT64_T */
#ifdef __SYNSOFT_GEN_SINT64_T
# undef __SYNSOFT_GEN_SINT64_T
#endif /* __SYNSOFT_GEN_SINT64_T */
#ifdef __SYNSOFT_GEN_INT64_T
# undef __SYNSOFT_GEN_INT64_T
#endif /* __SYNSOFT_GEN_INT64_T */

/* 128-bit. */
#ifdef __SYNSOFT_GEN_UINT128_T
# undef __SYNSOFT_GEN_UINT128_T
#endif /* __SYNSOFT_GEN_UINT128_T */
#ifdef __SYNSOFT_GEN_SINT128_T
# undef __SYNSOFT_GEN_SINT128_T
#endif /* __SYNSOFT_GEN_SINT128_T */
#ifdef __SYNSOFT_GEN_INT128_T
# undef __SYNSOFT_GEN_INT128_T
#endif /* __SYNSOFT_DBS_INT128_T */


/* Byte. */
#ifdef __SYNSOFT_GEN_UBYTE_T
# undef __SYNSOFT_GEN_UBYTE_T
#endif /* __SYNSOFT_GEN_UBYTE_T */
#ifdef __SYNSOFT_GEN_SBYTE_T
# undef __SYNSOFT_GEN_SBYTE_T
#endif /* __SYNSOFT_GEN_SBYTE_T */
#ifdef __SYNSOFT_GEN_BYTE_T
# undef __SYNSOFT_GEN_BYTE_T
#endif /* __SYNSOFT_GEN_BYTE_T */

/* Short. */
#ifdef __SYNSOFT_GEN_USHORT_T
# undef __SYNSOFT_GEN_USHORT_T
#endif /* __SYNSOFT_GEN_USHORT_T */
#ifdef __SYNSOFT_GEN_SSHORT_T
# undef __SYNSOFT_GEN_SSHORT_T
#endif /* __SYNSOFT_GEN_SSHORT_T */
#ifdef __SYNSOFT_GEN_SHORT_T
# undef __SYNSOFT_GEN_SHORT_T
#endif /* __SYNSOFT_GEN_SHORT_T */

/* Int. */
#ifdef __SYNSOFT_GEN_UINT_T
# undef __SYNSOFT_GEN_UINT_T
#endif /* __SYNSOFT_GEN_UINT_T */
#ifdef __SYNSOFT_GEN_SINT_T
# undef __SYNSOFT_GEN_SINT_T
#endif /* __SYNSOFT_GEN_SINT_T */
#ifdef __SYNSOFT_GEN_INT_T
# undef __SYNSOFT_GEN_INT_T
#endif /* __SYNSOFT_GEN_INT_T */

/* Long. */
#ifdef __SYNSOFT_GEN_ULONG_T
# undef __SYNSOFT_GEN_ULONG_T
#endif /* __SYNSOFT_GEN_ULONG_T */
#ifdef __SYNSOFT_GEN_SLONG_T
# undef __SYNSOFT_GEN_SLONG_T
#endif /* __SYNSOFT_GEN_SLONG_T */
#ifdef __SYNSOFT_GEN_LONG_T
# undef __SYNSOFT_GEN_LONG_T
#endif /* __SYNSOFT_GEN_LONG_T */

/* Long Long. */
#ifdef __SYNSOFT_GEN_ULLONG_T
# undef __SYNSOFT_GEN_ULLONG_T
#endif /* __SYNSOFT_GEN_ULLONG_T */
#ifdef __SYNSOFT_GEN_SLLONG_T
# undef __SYNSOFT_GEN_SLLONG_T
#endif /* __SYNSOFT_GEN_SLLONG_T */
#ifdef __SYNSOFT_GEN_LLONG_T
# undef __SYNSOFT_GEN_LLONG_T
#endif /* __SYNSOFT_GEN_LLONG_T */

/* Platform-pointer - sized int. */
#ifdef __SYNSOFT_GEN_UINTP_T
# undef __SYNSOFT_GEN_UINTP_T
#endif /* __SYNSOFT_GEN_UINTP_T */
#ifdef __SYNSOFT_GEN_SINTP_T
# undef __SYNSOFT_GEN_SINTP_T
#endif /* __SYNSOFT_GEN_SINTP_T */
#ifdef __SYNSOFT_GEN_INTP_T
# undef __SYNSOFT_GEN_INTP_T
#endif /* __SYNSOFT_GEN_INTP_T */


/* Floating point. */
#ifdef __SYNSOFT_GEN_FLOAT_T
# undef __SYNSOFT_GEN_FLOAT_T
#endif /* __SYNSOFT_GEN_FLOAT_T */
#ifdef __SYNSOFT_GEN_DOUBLE_T
# undef __SYNSOFT_GEN_DOUBLE_T
#endif /* __SYNSOFT_GEN_DOUBLE_T */
#ifdef __SYNSOFT_GEN_LDOUBLE_T
# undef __SYNSOFT_GEN_LDOUBLE_T
#endif /* __SYNSOFT_GEN_LDOUBLE_T */


/* QWord. */
#ifdef __SYNSOFT_DBS_WORD_SUPPORT
# undef __SYNSOFT_DBS_WORD_SUPPORT
#endif /* __SYNSOFT_DBS_WORD_SUPPORT */
#ifdef __SYNSOFT_DBS_DWORD_SUPPORT
# undef __SYNSOFT_DBS_DWORD_SUPPORT
#endif /* __SYNSOFT_DBS_DWORD_SUPPORT */
#ifdef __SYNSOFT_DBS_QWORD_SUPPORT
# undef __SYNSOFT_DBS_QWORD_SUPPORT
#endif /* __SYNSOFT_DBS_QWORD_SUPPORT */


/* Short. */
#ifdef __SYNSOFT_DBS_SHORT_BITSIZE
# undef __SYNSOFT_DBS_SHORT_BITSIZE
#endif /* __SYNSOFT_DBS_SHORT_BITSIZE */

/* Int. */
#ifdef __SYNSOFT_DBS_INT_BITSIZE
# undef __SYNSOFT_DBS_INT_BITSIZE
#endif /* __SYNSOFT_DBS_INT_BITSIZE */

/* Long. */
#ifdef __SYNSOFT_DBS_LONG_BITSIZE
# undef __SYNSOFT_DBS_LONG_BITSIZE
#endif /* __SYNSOFT_DBS_LONG_BITSIZE */

/* LLong. */
#ifdef __SYNSOFT_DBS_LLONG_BITSIZE
# undef __SYNSOFT_DBS_LLONG_BITSIZE
#endif /* __SYNSOFT_DBS_LLONG_BITSIZE */

/* /////////////////////////////////////////////////////////////////////////////
 * /////////////////////////////////////////////////////////////////////////////
 * 16. type specification
 */

#ifdef __SYNSOFT_NATIVE_BOOL_SUPPORT
# undef __SYNSOFT_NATIVE_BOOL_SUPPORT
#endif /* __SYNSOFT_NATIVE_BOOL_SUPPORT */

#ifdef __SYNSOFT_GEN_PTRDIFF_T
# undef __SYNSOFT_GEN_PTRDIFF_T
#endif /* __SYNSOFT_GEN_PTRDIFF_T */

#ifdef __SYNSOFT_GEN_SIZE_T
# undef __SYNSOFT_GEN_SIZE_T
#endif /* __SYNSOFT_GEN_SIZE_T */

#ifdef __SYNSOFT_GEN_WCHAR_T
# undef __SYNSOFT_GEN_WCHAR_T
#endif /* __SYNSOFT_GEN_WCHAR_T */

#ifdef __SYNSOFT_DBS_UNICODE
# undef __SYNSOFT_DBS_UNICODE
#endif /* __SYNSOFT_DBS_UNICODE */

#ifdef __SYNSOFT_DBS_ANSI
# undef __SYNSOFT_DBS_ANSI
#endif /* __SYNSOFT_DBS_ANSI */

#ifdef __SYNSOFT_DBS_SBCS
# undef __SYNSOFT_DBS_SBCS
#endif /* __SYNSOFT_DBS_SBCS */

#ifdef __SYNSOFT_DBS_MBCS
# undef __SYNSOFT_DBS_MBCS
#endif /* __SYNSOFT_DBS_MBCS */

#ifdef __SYNSOFT_DBS_MULTILANGUAGE_SUPPORT
# undef __SYNSOFT_DBS_MULTILANGUAGE_SUPPORT
#endif /* __SYNSOFT_DBS_MULTILANGUAGE_SUPPORT */

#ifdef __SYNSOFT_DBS_ANSI_SUPPORT
# undef __SYNSOFT_DBS_ANSI_SUPPORT
#endif /* __SYNSOFT_DBS_ANSI_SUPPORT */

#ifdef __SYNSOFT_DBS_UNICODE_SUPPORT
# undef __SYNSOFT_DBS_UNICODE_SUPPORT
#endif /* __SYNSOFT_DBS_UNICODE_SUPPORT */

#ifdef __SYNSOFT_DBS_SBCS_SUPPORT
# undef __SYNSOFT_DBS_SBCS_SUPPORT
#endif /* __SYNSOFT_DBS_SBCS_SUPPORT */

#ifdef __SYNSOFT_DBS_MBCS_SUPPORT
# undef __SYNSOFT_DBS_MBCS_SUPPORT
#endif /* __SYNSOFT_DBS_MBCS_SUPPORT */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* _SYNSOFT_INCL_H_SLBASUDF */

/* ////////////////////////////////////////////////////////////////////////// */
