/* ////////////////////////////////////////////////////////////////////////////
 * File:        SWrn004U.h
 *
 * Purpose:     Pushing of warning suppresion.
 *
 * Created:     10th November 2000
 * Updated:     18th February 2005
 *
 * Author:      Matthew Wilson, Synesis Software Pty Ltd.
 *
 * License:     (Licensed under the Synesis Software Standard Public License)
 *
 *              Copyright 2000-2005, Synesis Software Pty Ltd.
 *
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au
 *                          http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              Redistribution and use in source and binary forms, with or
 *              without modification, are permitted provided that the following
 *              conditions are met:
 *
 *              (i) Redistributions of source code must retain the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer.
 *
 *              (ii) Redistributions in binary form must reproduce the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer in the documentation
 *              and/or other materials provided with the distribution.
 *
 *              (iii) Any derived versions of this software (howsoever modified)
 *              remain the sole property of Synesis Software.
 *
 *              (iv) Any derived versions of this software (howsoever modified)
 *              remain subject to all these conditions.
 *
 *              (v) Neither the name of Synesis Software nor the names of any
 *              subdivisions, employees or agents of Synesis Software, nor the
 *              names of any other contributors to this software may be used to
 *              endorse or promote products derived from this software without
 *              specific prior written permission.
 *
 *              This source code is provided by Synesis Software "as is" and any
 *              warranties, whether expressed or implied, including, but not
 *              limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software be liable for any direct, indirect,
 *              incidental, special, exemplary, or consequential damages
 *              (including, but not limited to, procurement of substitute goods
 *              or services; loss of use, data, or profits; or business
 *              interruption) however caused and on any theory of liability,
 *              whether in contract, strict liability, or tort (including
 *              negligence or otherwise) arising in any way out of the use of
 *              this software, even if advised of the possibility of such
 *              damage.
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef _SYNSOFT_INCL_H_SLBASE
#error Cannot include this file before SLBase.h
#endif /* _SYNSOFT_INCL_H_SLBASE */

#ifdef _SYNSOFT_INCL_H_SWRN004U
#error Cannot include SWrn004u.h multiple times within a compilation unit without including matching SWrn004o.h
#else
#define _SYNSOFT_INCL_H_SWRN004U
#endif /* _SYNSOFT_INCL_H_SWRN004U */

#ifdef _SYNSOFT_INCL_H_SWRN004O
#undef _SYNSOFT_INCL_H_SWRN004O
#endif /* _SYNSOFT_INCL_H_SWRN004O */

/* ///////////////////////////////////////////////////////////////////////// */

#ifndef _SYNSOFT_VER_H_SWRN004U_MAJOR
#ifndef _SYNSOFT_DOCUMENTATION_SKIP_SECTION
# define _SYNSOFT_VER_H_SWRN004U_MAJOR        1
# define _SYNSOFT_VER_H_SWRN004U_MINOR        2
# define _SYNSOFT_VER_H_SWRN004U_REVISION     2
# define _SYNSOFT_VER_H_SWRN004U_EDIT         11
#endif /* !_SYNSOFT_DOCUMENTATION_SKIP_SECTION */
#endif /* _SYNSOFT_VER_H_SWRN004U_MAJOR */

#ifdef _SYB_TRACE_INCLUDE_PATH
#pragma message(__FILE__)
#endif /* _SYB_TRACE_INCLUDE_PATH */

/* Warning management. */

#if !defined(_SYB_NO_WARNING_SUPPRESSION) && \
    !defined(_SYB_NO_WARNING_SUPPRESSION_004) && \
    !defined(_SYB_NO_WARNING_SUPPRESSION_004u)

/* Type definition in parentheses. */

#if __SYNSOFT_DVS_COMPILER == __SYNSOFT_VAL_COMPILER_BORLAND
#if 0
#pragma warn -80xx                  /* Suppresses: "" */
#endif /* 0 */
#elif __SYNSOFT_DVS_COMPILER == __SYNSOFT_VAL_COMPILER_MSVC
#if __SYNSOFT_DVS_COMPILER_VER_MSVC >= 0x00060000
#pragma warning(push)
#endif /* __SYNSOFT_DVS_COMPILER_VER_MSVC >= 0x00060000 */
#pragma warning(disable : 4115)     /* Suppresses: "named type definition in parentheses" */
#endif /* __SYNSOFT_DVS_COMPILER != __SYNSOFT_VAL_COMPILER_MSVC */

#endif /* !_SYB_NO_WARNING_SUPPRESSION && !_SYB_NO_WARNING_SUPPRESSION_004(u) */

/* ///////////////////////////////////////////////////////////////////////// */
